<template>
  <div class="chart" :id="id"></div>
</template>

<script>
import util from "@/helper/util.js";
import partten from "@/helper/partten.js";
import * as echarts from "echarts";

export default {
  name: "normal-line-chart",
  componentName: "normal-line-chart",
  props: {
    width: {
      type: String,
      default: "100%",
    },
    height: {
      type: String,
      default: "13.889vh",
    },
    // 数据
    list: {
      type: Array,
      default: () => [
        {
          title: "日发电量",
          yAxisIndex: 0,
          value: [
            {
              text: "1",
              value: 1,
            },
            {
              text: "2",
              value: 2,
            },
            {
              text: "3",
              value: 1,
            },
            {
              text: "4",
              value: 3,
            },
            {
              text: "5",
              value: 3,
            },
            {
              text: "6",
              value: 3,
            },
            {
              text: "7",
              value: 3,
            },
            {
              text: "8",
              value: 3,
            },
            {
              text: "9",
              value: 3,
            },
            {
              text: "10",
              value: 3,
            },
            {
              text: "11",
              value: 3,
            },
            {
              text: "12",
              value: 3,
            },
            {
              text: "13",
              value: 3,
            },
            {
              text: "14",
              value: 3,
            },
            {
              text: "15",
              value: 3,
            },
            {
              text: "16",
              value: 3,
            },
          ],
        },
        {
          title: "上网电量",
          yAxisIndex: 0,
          value: [
            {
              text: "1",
              value: 1,
            },
            {
              text: "2",
              value: 2,
            },
            {
              text: "3",
              value: 1,
            },
            {
              text: "4",
              value: 3,
            },
          ],
        },
      ],
    },
    // 单位
    units: {
      type: Array,
      default: () => ["(MW)"],
    },
  },
  data () {
    return {
      id: "",
      chart: null,
      color: ["#05bb4c", "#4b55ae", "#fa8c16", "#f8de5b"],
    };
  },
  computed: {
    xdata () {
      return this.list[0].value.map((t) => {
        return t.text;
      });
    },
    yAxis () {
      let result = [];
      this.units.forEach((value, index) => {
        result.push({
          type: "value",
          name: value,
          axisLabel: {
            formatter: "{value}",
            fontSize: util.vh(14),
          },
          //分格线
          splitLine: {
            lineStyle: {
              color: partten.getColor("gray"),
              type: "dashed",
            },
          },
        });
      });

      return result;
    },
    series () {
      let result = [];

      this.list.forEach((value, index) => {
        result.push({
          name: value.title,
          type: "line",
          smooth: true,
          zlevel: index,
          lineStyle: {
            normal: {
              color: this.color[index],
            },
          },
          yAxisIndex: value.yAxisIndex,
          data: value.value.map((t) => {
            return t.value;
          }),
        });
      });

      return result;
    },
  },
  methods: {
    hexToRgba (hex, opacity) {
      let rgbaColor = "";
      let reg = /^#[\da-f]{6}$/i;
      if (reg.test(hex)) {
        rgbaColor = `rgba(${parseInt("0x" + hex.slice(1, 3))},${parseInt("0x" + hex.slice(3, 5))},${parseInt("0x" + hex.slice(5, 7))},${opacity})`;
      }
      return rgbaColor;
    },
    initChart () {
      let option = {
        color: this.color,
        tooltip: {
          trigger: "item",
          backgroundColor: "rgba(255,255,255,0.3)",
          textStyle: {
            color: "#fff",
            fontSize: util.vh(16),
          },
          formatter: function (param) {
            console.log(param);
            return param.name + "<br >" + param.marker + param.seriesName + "：" + param.value;
          },
        },
        grid: {
          top: util.vh(32),
          left: util.vh(40),
          right: util.vh(40),
          bottom: util.vh(24),
        },
        xAxis: [
          {
            type: "category",
            boundaryGap: false,
            axisLabel: {
              formatter: "{value}",
              fontSize: util.vh(14),
              textStyle: {
                color: partten.getColor("gray"),
              },
            },
            data: this.xdata,
          },
        ],
        yAxis: this.yAxis,
        series: this.series,
      };

      this.chart.setOption(option);
    },
  },
  created () {
    this.$nextTick(() => {
      this.id = "pie-chart-" + util.newGUID();
    });
  },
  mounted () {
    this.$nextTick(() => {
      this.$el.style.width = this.width;
      this.$el.style.height = this.height;
      this.chart = echarts.init(this.$el);
      this.initChart();
    });
  },
  updated () {
    this.$nextTick(() => {
      this.initChart();
    });
  },
};
</script>

<style lang="less">
.chart {
  width: 100%;
  height: 100%;
  display: inline-block;
}
</style>
